Package: touch
Title: Tools of Utilization and Cost in Healthcare
Version: 0.1-7
Authors@R: c(
    person(given = "Wenjie", family = "Wang",
           role = c("aut", "cre"),
           email = "wang@wwenjie.org",
           comment = c(ORCID = "0000-0003-0363-3180")),
    person(given = "Yan", family = "Li", role = "aut"),
    person(given = "Jun", family = "Yan", role = "aut",
           comment = c(ORCID = "0000-0003-4401-7296"))
    )
Description: R implementation of the software tools developed in the H-CUP
    (Healthcare Cost and Utilization Project) <https://hcup-us.ahrq.gov>
    and AHRQ (Agency for Healthcare Research and Quality)
    <https://www.ahrq.gov>.  It currently contains functions for mapping ICD-9
    codes to the AHRQ comorbidity measures and translating ICD-9
    (resp. ICD-10) codes to ICD-10 (resp. ICD-9) codes based on GEM (General
    Equivalence Mappings) from CMS (Centers for Medicare and Medicaid
    Services).
Depends: R (>= 3.2.0)
LinkingTo: Rcpp
Imports: Rcpp
License: GPL (>= 3)
LazyData: yes
SysDataCompression: xz
URL: https://github.com/wenjie2wang/touch
BugReports: https://github.com/wenjie2wang/touch/issues
Encoding: UTF-8
NeedsCompilation: yes
Packaged: 2025-11-27 21:47:01 UTC; wenjie
Author: Wenjie Wang [aut, cre] (ORCID: <https://orcid.org/0000-0003-0363-3180>),
  Yan Li [aut],
  Jun Yan [aut] (ORCID: <https://orcid.org/0000-0003-4401-7296>)
Maintainer: Wenjie Wang <wang@wwenjie.org>
Repository: CRAN
Date/Publication: 2025-11-27 22:20:02 UTC
Built: R 4.6.0; x86_64-apple-darwin20; 2026-04-27 04:43:03 UTC; unix
Archs: touch.so.dSYM

# R Package touch

[![CRAN_Status_Badge][cranVersion]][cran]
[![Build Status][gha-icon]][gha-url]


The package **touch** (**T**ools **o**f **u**nilization and **c**ost in
**h**ealthcare) provides **R** implementation of the software tools developed
in the H-CUP (Healthcare Cost and Utilization Project) and AHRQ (Agency for
Healthcare Research and Quality).


It currently contains functions for

- mapping ICD-9 codes to the AHRQ comorbidity measures
- translating ICD-9 (resp. ICD-10) codes to ICD-10 (resp. ICD-9) codes based
  on GEM (General Equivalence Mappings) from CMS (Centers for Medicare and
  Medicaid Services).


## Installation

You may install the released version from [CRAN][cran].

```R
install.packages("touch")
```


## Development

One may install the latest version under development as follows:

```R
if (! require(remotes)) install.packages("remotes")
remotes::install_github("wenjie2wang/touch", upgrade = "never")
```

## License

GNU General Public License (≥ 3)


[cranVersion]: https://www.r-pkg.org/badges/version/touch
[cran]: https://CRAN.R-project.org/package=touch
[gha-icon]: https://github.com/wenjie2wang/touch/actions/workflows/R-CMD-check.yaml/badge.svg
[gha-url]: https://github.com/wenjie2wang/touch/actions

The cmbdGen.R script uses code table to generate functions
to be stored in sysdata.rda.

Input:  icd.txt, drg.txt, htncx_renlfail.txt
Output: sysdata.rda


The input file htncx_renlfail.txt is got from
reading and understanding the usage of CARDDRG and RENALDRG
code for two special comorbidities HTNCX and RENLFAIL.
And icd.txt and drg.txt are generated from
CodeGen/FormatCode.R.

For formatcode,

Input : http url of sas format code stored in sas-url.txt,
        icd-combination.txt, drg-combination.txt
Output: icd.txt, drg.txt

The icd-combination.txt file describes how to combine
the temporary 40 groups of ICD-9 coding defined in the
Format program at arhq website to get the ICD-9 coding
for each of 29 comorbidities used in cmbdGen.R.

The drg-combination.txt file contains how to combine
the temporary 24 groups of DRG coding defined in the
Format program at arhq website to get the DRG coding
for each of 29 comorbidities used in cmbdGen.R.

FormatCode.R uses readlines and regular expression to get
the 40 groups of ICD-9 coding and 24 groups of DRG coding
at arhq website and then combines them to generate DRG coding
and ICD-9 coding for cmbdGen.R.

input : sas-url.txt, drg-combination.txt, icd-combination.txt

output : icd.txt, drg.txt

## aggregate diagnosis codes
aggregate_dx <- function(dx, flags = NULL)
{
    ## remove empty strings and NA's
    idx <- is.na(dx) | dx == ""
    dx <- dx[! idx]
    if (length(dx) > 1) {
        if (is.null(flags)) {
            return(paste(dx, collapse = ","))
        }
        flags <- flags[! idx]
        ## combination flags
        flag3 <- as.integer(substr(flags, start = 3, stop = 3))
        is_comb <- ! is.na(flag3) & flag3 == 1L
        if (any(is_comb)) {
            dx1 <- dx[! is_comb]
            comb_dx <- dx[is_comb]
            comb_flags <- flags[is_comb]
            ## scenario flags
            flag4 <- as.integer(substr(comb_flags, start = 4, stop = 4))
            ## choice flags
            flag5 <- as.integer(substr(comb_flags, start = 5, stop = 5))
            dx2_list <- lapply(unique(flag4), function(i) {
                idx <- flag4 == i
                sub_flag5 <- flag5[idx]
                u_flag5 <- sort(unique(sub_flag5))
                idx_list <- lapply(u_flag5, function(a) {
                    which(sub_flag5 == a)
                })
                names(idx_list) <- as.character(u_flag5)
                call_list <- c(idx_list,
                               list(KEEP.OUT.ATTRS = FALSE,
                                    stringsAsFactors = FALSE)
                               )
                grid_mat <- as.matrix(do.call(expand.grid, call_list))
                sapply(seq_len(nrow(grid_mat)), function(ii) {
                    paste(comb_dx[idx][grid_mat[ii, ]], collapse = "+")
                })
            })
            dx2 <- paste(do.call(c, dx2_list), collapse = ",")
            if (length(dx1) > 0)
                paste(paste(dx1, collapse = ","), dx2, sep = ",")
            else
                dx2
        } else {
            paste(dx, collapse = ",")
        }
    } else if (length(dx) == 0L) {
        ""
    } else
        dx
}

## a simple function to combine multiple RData files into one RData file
combine_rda <- function(in_file, ..., out_file)
{
    rda_list <- list(in_file, ...)
    rda_env <- new.env()
    for (i in seq_along(rda_list)) {
        load(rda_list[[i]], rda_env)
    }
    save(list = ls(rda_env), file = out_file, envir = rda_env,
         compress = "xz", compression_level = 9, version = 2)
}


##' Check, Install and Attach Multiple R packages Specified
##'
##' The function is a simple wrapper that aims to simplify the process of
##' attaching multiple packages that are not necessarily available.  It first
##' checks whether the packages given were already installed and would try to
##' install them from specified repository if needed.  At last, it attachs all
##' the needed packages to the search path.
##'
##' See the source code for details.
##'
##' @param pkgs A character vector specifying the packages needed to reproduce
##'     this document.
##' @param repos A character vector for the base URL(s) of the repositories
##'     containing the source.  The default mirror is
##'     \code{"https://cloud.r-project.org"} and will be used if \code{repos}
##'     is not set.
##' @param ... Other arguments passed to function
##'     \code{\link[utils]{install.packages}}.
##'
##' @return \code{NULL} invisibly.
##' @examples
##' \dontrun{
##' need.pacakges(c("splines2", "reda"))
##' }
##' @importFrom utils installed.packages install.packages
##' @export
need.packages <- function(pkgs, repos = getOption("repos"), ...)
{
    new.pkgs <- pkgs[! (pkgs %in% installed.packages()[, "Package"])]
    if (length(new.pkgs) > 0) {
        if (is.null(repos) || repos == "@CRAN@") {
            repos <- "https://cloud.r-project.org"
        }
        install.packages(pkgs = new.pkgs, repos = repos, ...)
    }
    sapply(pkgs, function(a) {
        suppressMessages(require(a, character.only = TRUE))
    })
    invisible()
}

.icd9tab <- read.table("icd.txt", sep=":", as.is=TRUE)
.drg29tab <- read.table("drg.txt", sep=":", as.is=TRUE)
.drgspecial <- read.table("htncx_renlfail.txt", sep=":", as.is=TRUE)

## creat a function to match codes
codeMatch.1 <- function(codes) {
  codes <- gsub("E", "11", codes) ## gsub instead of sub!
  codes <- gsub("V", "12", codes)
  if (codes == "") return(function(x) rep(FALSE, length(x)))
  ll <- strsplit(codes, ",")[[1]]
  isRange <- grepl("-", ll)
  textV <- textR <- ""
  if (any(!isRange)) {
    vc <- ll[!isRange]
    textV <- paste("(x %in% c(", paste(vc, collapse=", "), "))")
  }
  if (any(isRange)) {
    ran <- t(as.data.frame(lapply(strsplit(ll[isRange], "-"), as.numeric)))
    textR <- paste("(", "x >= ", ran[,1], " & ", "x <= ", ran[,2], ")")
    textR <- paste(textR, collapse = " | ")
  }
  both <- length(table(isRange)) > 1
  sep <- if (both) " | " else ""
  text <- paste(textV, textR, sep=sep)
  fun <- function(x) {}
  body(fun) <- parse(text=text)
  fun
}

# input htncx_renlfail.txt and create function
# to compute the drg flags for 2 comorbidities
# HTNCX and RENLFAIL with carddrg and renaldrg
specialDrg.2 <- function(codes) {
  ll <- strsplit(codes, ",")[[1]]
  ll <- trimws(ll)
  text <- ""
  text <- paste0("with(icd, rowSums(cbind(", paste(ll, collapse=", "), ")))")
  fun <- function(icd, CARDDRG, RENALDRG) {}
  body(fun) <- parse(text=text)
  fun
}

## a list of functions for icd9 codes
cmbdFuns <- sapply(1:nrow(.icd9tab),
                   function(i) codeMatch.1(.icd9tab[i,2])
                   )

names(cmbdFuns) <- .icd9tab[,1]

## a list of functions for drg code
drgFuns <- sapply(1:nrow(.drg29tab),
                  function(i) codeMatch.1(.drg29tab[i,2])
                  )
names(drgFuns) <- .drg29tab[,1]

## a list of functions for handling drg flags for two comorbidities
specdrgFuns <- sapply(1:nrow(.drgspecial),
                  function(i) specialDrg.2(.drgspecial[i,2])
)

names(specdrgFuns) <- .drgspecial[,1]

save(cmbdFuns, drgFuns, specdrgFuns,
     file='../../R/sysdata.rda', compress=TRUE)

CatchCode <- function(x) {
  # Arg:
  #  x: url of SAS format code
  # output:
  #  DRG.code: DRG codes for temporary 24 DRG group
  #  DRG.class: DRG name for temporary 24 DRG group
  #  ICD.code: ICD-9 codes for temporary 40 comorbidity group
  #  ICD.class: ICD-9 name for temporary 40 comorbidity group
  format.txt <- readLines(url)
  # delete all the SAS annotation and code rows, keep the ICD-9-CM and DRG codes
  format.txt <- trimws(grep(pattern="\\d|=|VALUE", x=format.txt, value=TRUE))
  format.txt <- format.txt[which(substr(format.txt, start=1, stop=1) != "/")]
  Fstart <- format.txt[which(substr(format.txt, start=1, stop=1) == '"')][1]
  format.txt <- format.txt[-(1 : which(format.txt == Fstart) - 1)]
  # select rows that contains the names of DRG group
  DRG.name <- grep(pattern="VALUE", x=format.txt, value=TRUE)
  DRG.order <- NULL
  for (i in 1:length(DRG.name)) {
    DRG.order <- c(DRG.order, which(format.txt == DRG.name[i]))
  }

  DRG.class <- NULL
  # store the names of DRG in DRG.class array using the names like CARDDRG
  for (i in 1 : length(DRG.name)) {
    start.flag <- str_locate(DRG.name[i], pattern='(DRG)')[[1]]
    DRG.class <- c(DRG.class, substr(DRG.name[i],
                                     start=6,
                                     stop=start.flag[length(start.flag)]+2))
    DRG.class <- trimws(DRG.class)
  }

  DRG.code <- NULL
  # by Group catenate all of the strings containing the DRG codes
  for (i in 1 : (length(DRG.order))) {
    DRG.code.k <- " "
    if(i!=length(DRG.order)) {
      for(k in (DRG.order[i] + 1) : (DRG.order[i + 1] - 1)) {
        DRG.code.k <- str_c(DRG.code.k, format.txt[k], sep="")
      }
    } else {
      for(k in (DRG.order[i] + 1) : length(format.txt)) {
        DRG.code.k <- str_c(DRG.code.k, format.txt[k], sep="")
      }
    }
    DRG.code <-c(DRG.code, DRG.code.k)
  }
  # remove the SAS annotation in DRG.code
  eq.start <- subset(str_locate(DRG.code, pattern="="), select=start)
  DRG.code <- substr(DRG.code, start=1, stop=eq.start-1)
  DRG.code <- trimws(DRG.code)
  DRG.code <- str_replace_all(DRG.code, pattern=' ', replacement="")
  DRG.code <- str_replace_all(DRG.code, pattern=',', replacement=", ")

  # handling ICD-9 codes
  ICD <- format.txt[1 : (DRG.order[1]-2)]

  ICD.name <- grep(pattern="=", x=ICD, value=TRUE)

  ICD.order <- NULL ## the numbers of row containing comorbodity names.
  for (i in 1:length(ICD.name)) {
    ICD.order <- c(ICD.order, which(format.txt == ICD.name[i]))
  }
  # select comorbodity nanmes and store in ICD.name
  eq.order <- subset(str_locate(ICD.name, pattern="="), select=start)
  a.order <- subset(str_locate(ICD.name, pattern="(/)"), select=start)
  ICD.class <- trimws(substr(ICD.name, start= eq.order+1, stop=a.order-1))
  ICD.class <- str_replace_all(ICD.class, pattern='\"', replacement="")

  ICD.code <- NULL
  for (i in 1 : (length(ICD.order))) {
    ICD.code.k <- " "
    if(i!=1) {
      for(k in (ICD.order[i-1] + 1) : (ICD.order[i])) {
        ICD.code.k <- str_c(ICD.code.k, format.txt[k], sep="")
      }
    } else {
      for(k in 1 : ICD.order[i]) {
        ICD.code.k <- str_c(ICD.code.k, format.txt[k], sep="")
      }
    }
    ICD.code <-c(ICD.code, ICD.code.k)
  }
  I <- subset(str_locate(ICD.code, pattern="="), select=start)

  ICD.code <- trimws(substr(ICD.code, start= 1, stop=I-1))
  ICD.code <- str_replace_all(ICD.code, pattern=' ', replacement="")
  ICD.code <- str_replace_all(ICD.code, pattern=',', replacement=", ")
  ICD.code <- str_replace_all(ICD.code, pattern='\"', replacement="")
  list(DRG.code=DRG.code, DRG.class=DRG.class,
       ICD.code=ICD.code, ICD.class=ICD.class)
}

Adddot <- function(input) {
  # Change the codes from SAS by adding dot after third digit
  # Inputs:
  #  ICD-9 codes got from SAS format code
  # Outputs:
  #  ICD-9 codes with three integers and two decimals
  ll <- input
  ll <- strsplit(ll, ",")[[1]]
  aa <- ";"
  for(k in 1:length(ll)) {
    ll[k] <- trimws(ll[k])
    isE <- grepl("E", ll[k])
    isV <- grepl("V", ll[k])
    isRange <- grepl("-", ll[k])
    if(!isRange) {
      nc <- nchar(ll[k])
      ll[k] <- gsub("E", "11", ll[k])
      ll[k] <- gsub("V", "12", ll[k])
      ll[k] <- ifelse(nc == 3, paste(ll[k], "00", sep=""), ll[k])
      ll[k] <- ifelse(nc == 4, paste(ll[k], "0", sep=""), ll[k])
      ll[k] <- as.numeric(ll[k]) / 100
      ll[k] <- ifelse(isE, paste("E", substr(ll[k], start=3,
                                          stop=nchar(ll[k])), sep=""), ll[k])
      ll[k] <- ifelse(isV, paste("V", substr(ll[k], start=3,
                                          stop=nchar(ll[k])), sep=""), ll[k])
    } else {
      inter <- trimws(strsplit(ll[[k]], "-")[[1]])
      inter <- sapply(inter,
                      function(x) {
                        x <- ifelse(nchar(x) == 4, paste(x, "0", sep=""), x)
                             ifelse(nchar(x) == 3, paste(x, "00", sep=""), x)
                      })
      inter <- gsub("E", "11", inter)
      inter <- gsub("V", "12", inter)
      inter <- sapply(inter, function(x) {as.numeric(x) / 100})
      inter <- sapply(inter,
                      function(x) {ifelse(isE, paste("E", substr(x, start=3,
                                             stop=nchar(x)), sep=""), x)})
      inter <- sapply(inter,
                      function(x) {ifelse(isV, paste("V", substr(x, start=3,
                                             stop=nchar(x)), sep=""), x)})
      ll[k] <- str_c(inter[1], inter[2], sep="-")
    }
  aa <- str_c(aa, ll[k], sep=", ")
  }
  sub("(;, )", "", aa)
}

MatchCode <- function(comb, code) {
  # match icd or drg comb with icd or drg code
  # args:
  #  comb: icd.comb or drg.comb
  #  code: icd or drg code
  seprt <- subset(str_locate(comb, pattern="="), select=start)
  cmbd.name <- trimws(substr(comb, start=1, stop=seprt-1))
  cmbd.comb <- trimws(substr(comb, start=seprt+1, stop=nchar(comb)))

  cmbd <- list()
  for(i in 1:length(cmbd.comb)) {
    m <- trimws(str_split_fixed(cmbd.comb[i], pattern=",",
                                  n=str_count(cmbd.comb[i], pattern=',')+1))
    cmbd[[i]] <- m
  }
  names(cmbd) <- cmbd.name
  for(i in 1:length(cmbd)) {
    cmbd.i <- ""
    for(j in 1:length(cmbd[[i]])) {
      num <- which(names(code)==cmbd[[i]][j])
      if(cmbd.i == "") {
        cmbd.i <- str_c(cmbd.i, code[[num]], sep="")
      } else {
        cmbd.i <- str_c(cmbd.i, code[[num]], sep=", ")
      }
    }
    cmbd[[i]] <- cmbd.i
  }
  cmbd
}

Matchnames <- function(code) {
  # change list of code to charactor vectors
  f <- NULL
  name <- names(code)
  for(i in 1:length(code)) {
    f <- c(f, paste0(name[i], ": ", code[[i]]))
  }
  str_replace_all(f, pattern="'", replacement="")
}

url <- read.table("sas-url.txt")[[6]]
url <- as.character(url)

cmbd <- CatchCode(url)

ICD.code <- cmbd$ICD.code
ICD.class <- cmbd$ICD.class
DRG.code <- cmbd$DRG.code
DRG.class <- cmbd$DRG.class

drg <- as.list(DRG.code)
names(drg) <- DRG.class
icd <- as.list(ICD.code)
icd <- lapply(icd, Adddot)
names(icd) <- ICD.class

# according to DRG_combination.txt, generate a final drg.txt like the txt in Git
drg.comb <- readLines('drg-combination.txt')
cmbd.drg <- MatchCode(drg.comb, drg)

# according to icd_combination.txt, generate a final drg.txt like the txt in Git
icd.comb <- readLines('icd-combination.txt')
cmbd.icd <- MatchCode(icd.comb, icd)

f.drg <- Matchnames(cmbd.drg)
f.icd <- Matchnames(cmbd.icd)

cat(f.drg, file="../drg.txt", sep="\n")
cat(f.icd, file="../icd.txt", sep="\n")

library(touch)

### some random ICD-9 and ICD-10 codes
icd9codes <- c("0011", "001.1", "316", "29383", "E9808", "V90")
icd10codes <- c("F0390", "F0630", "F54", "F30.13", "A010", "M61019")

### forward mapping from ICD-9 to ICD-10
icd_map(icd9codes)
icd_map(icd9codes, decimal = TRUE, nomatch = NA)

### backward mapping from ICD-10 to ICD-9
icd_map(icd10codes, from = 10, to = 9)
icd_map(icd10codes, from = 10, to = 9, nomatch = NA, output = "list")
icd_map(icd10codes, from = 10, to = 9,
        decimal = TRUE, nomatch = NA, output = "tidy")

### reverse-backward mapping from ICD-9 to ICD-10
icd_map(icd9codes, method = "reverse-gem")
icd_map(icd9codes, method = "reverse", decimal = TRUE, nomatch = NA)

### reverse-forward mapping from ICD-10 to ICD-9
icd_map(icd10codes, from = 10, to = 9, method = "reverse-gem")
icd_map(icd10codes, from = 10, to = 9, method = "reverse",
        decimal = TRUE, nomatch = NA)

### forward and reverse-backward mapping from ICD-9 to ICD-10
icd_map(icd9codes, method = "both")
icd_map(icd9codes, method = "both", decimal = TRUE, nomatch = NA)

### backward and reverse-forward mapping from ICD-10 to ICD-9
icd_map(icd10codes, from = 10, to = 9, method = "both")
icd_map(icd10codes, from = 10, to = 9, method = "both",
        decimal = TRUE, nomatch = NA)

### multi-stage process mapping ICD-9 to ICD-10
icd_map(icd9codes, method = "multi-stage")
icd_map(icd9codes, method = "multi-stage", decimal = TRUE, nomatch = NA)

### multi-stage process mapping ICD-10 to ICD-9
icd_map(icd10codes, from = 10, to = 9,
        method = "multi-stage", cache = FALSE)
icd_map(icd10codes, from = 10, to = 9, method = "multi-stage",
        decimal = TRUE, nomatch = NA, cache = FALSE)

### For codes with positive combination flags
icd_map("24951", output = "list")
## where the "+" signs indicate the code combinations

#!/usr/bin/Rscript --vanilla


### This script simply downloads General Equivalence Mappings (GEM) from AHRQ
base_url <- "https://www.cms.gov/Medicare/Coding/ICD10/Downloads"

## GEM for year 2017
gem17_zip <- "2017-GEM-DC.zip"

## GEM for year 2018
gem18_zip <- "2018-ICD-10-CM-General-Equivalence-Mappings.zip"

## define output directory
outDir <- "downloads"
if (! dir.exists(outDir)) dir.create(outDir)

## download all
gem_zips <- c(gem17_zip, gem18_zip)
for (i in gem_zips) {
    outFile <- file.path(outDir, i)
    download.file(file.path(base_url, i), destfile = outFile)
    unzip(outFile, exdir = outDir)
    unlink(outFile)
    unlink(file.path(outDir, "*.pdf"), force = TRUE)
}

#!/usr/bin/Rscript --vanilla


################################################################################
### This script generates the four mappings from ICD-9 (ICD-10) codes
### based on the CMS General Equivalence Mapping (GEM) from the map data
###
### 1. the GEM forward mapping from ICD-9 to ICD-10
### 2. the reverse of the forward mapping
### 3. the GEM backward mapping from ICD-10 to ICD-9
### 4. the reverse of the backward mapping
###
### version controlled by git
################################################################################


### set up tools
## just in case for using Rscript
library(methods)

## global settings
options(stringsAsFactors = FALSE)

## load helpers and packages
source("misc.R")
pkgs <- "data.table"
need.packages(pkgs)

## i/o
inDir <- "downloads"

## gem of year 2017 and 2018
years <- c(2017, 2018)
forward_files <- sprintf("%d_I9gem.txt", years)
backward_files <- sprintf("%d_I10gem.txt", years)

## for all data years
for (i in seq_along(years)) {

    forward_file <- forward_files[i]
    backward_file <- backward_files[i]

    ## on the forward mapping ==================================================
    forward_dat <- fread(file = file.path(inDir, forward_file),
                         header = FALSE)
    colnames(forward_dat) <- c("icd9_codes", "icd10_codes", "flag")

    ## remove "NoDx"
    forward_dat[, sum(icd10_codes == "NoDx"), ]
    forward_dat[, sum(icd9_codes == "NoDx"), ]
    forward_dat <- forward_dat[icd10_codes != "NoDx" & icd9_codes != "NoDx", ]

    ## aggregate icd-10 codes for the same icd-9 code
    forward_agg_icd10 <-
        forward_dat[, .(icd10_codes = aggregate_dx(icd10_codes, flag)),
                    keyby = icd9_codes]
    forward_name <- sprintf("forward_map_%d", years[i])
    assign(forward_name, forward_agg_icd10)

    ## aggregate icd-9 codes for the same icd-10 code
    forward_agg_icd9 <-
        forward_dat[, .(icd9_codes = aggregate_dx(icd9_codes, flag)),
                    keyby = icd10_codes]
    reverse_forward_name <- sprintf("reverse_forward_map_%d", years[i])
    assign(reverse_forward_name, forward_agg_icd9)

    ## on the backward mapping =================================================
    backward_dat <- fread(file = file.path(inDir, backward_file),
                          header = FALSE)
    colnames(backward_dat) <- c("icd10_codes", "icd9_codes", "flag")

    ## remove "NoDx"
    backward_dat[, sum(icd9_codes == "NoDx"), ]
    backward_dat[, sum(icd10_codes == "NoDx"), ]
    backward_dat <- backward_dat[icd9_codes != "NoDx" & icd10_codes != "NoDx", ]

    ## aggregate icd-9 codes for the same icd-10 code
    backward_agg_icd9 <-
        backward_dat[, .(icd9_codes = aggregate_dx(icd9_codes, flag)),
                     keyby = icd10_codes]
    backward_name <- sprintf("backward_map_%d", years[i])
    assign(backward_name, backward_agg_icd9)

    ## aggregate icd-10 codes for the same icd-9 code
    backward_agg_icd10 <-
        backward_dat[, .(icd10_codes = aggregate_dx(icd10_codes, flag)),
                     keyby = icd9_codes]
    reverse_backward_name <- sprintf("reverse_backward_map_%d", years[i])
    assign(reverse_backward_name, backward_agg_icd10)

    ## save all mappings into a RData file
    save(list = c(forward_name, reverse_forward_name,
                  backward_name, reverse_backward_name),
         file = sprintf("gem_%d.RData", years[i]))
}

## combine the current R/sysdata.rda with mapping environments
all_rda <- c("../../R/sysdata.rda", sprintf("gem_%d.RData", years))
all_rda_list <- as.list(all_rda)
do.call(combine_rda, c(all_rda_list, out_file = all_rda[1]))

## clean RData files
unlink(all_rda[- 1L], force = TRUE)
